#TEMPLATE(BitListClass2,'J&S Bitlist Template'),FAMILY('ABC')
#!-----------------------------------------------------------------------------!
#! J&S BitList Class 1.9901
#! Template
#! Copyright (c) 2000 by J&S Software Co. (jeff@jssoftware.com)
#!-----------------------------------------------------------------------------!
#! The in-column tagging method as well as the icons have been
#! borrowed (with permission) from Mike Hanson's SuperTagging templates.
#!-----------------------------------------------------------------------------!
#!The contents of this file are subject to the CoveComm Inc. Developers Open 
#!Source Public License Version 1.0 (the "License"); you may not use this 
#!product except in compliance with the License. You may obtain a copy of 
#!the License at http://www.clarionmag.com/common/dosl.html. Software 
#!distributed under the License is distributed on an "AS IS" basis, WITHOUT 
#!WARRANTY OF ANY KIND, either express or implied. See the License for the 
#!specific language governing rights and limitations under the License. 
#!The Original Code is Copyright (c) by J&S Software Co., released
#!June 28, 1999. The Initial Developer of the Original Code is Jeff Slarve. 
#!-----------------------------------------------------------------------------!
#! Synopsis                                                                     
#!                                                                              
#! A quick and easy interface to the "bits" available within integers.          
#! Allows the developer to quickly label each bit and present it to the user    
#! in the form of a psuedo "check box" instead of declaring a BYTE variable     
#! and populating a CHECK control for each switch.                              
#!                                                                              
#! The number of records displayed in the listbox are dictated by two things:   
#!    1. The StartingBit                                                        
#!    2. The number of items passed in the PARMS parameter of the INIT() method.
#!
#!-----------------------------------------------------------------------------!
#CONTROL(Bitlist,'Bitlist Control'),MULTI,DESCRIPTION('Bitlist2 (' & %JSBLClassName & ')')
   CONTROLS
     LIST,AT(,,100,50),USE(?BitList),NOBAR,VSCROLL,FORMAT('11C|I@s1@500L(2)@s60@')
   END
#AT(%CustomGlobalDeclarations)
  #PROJECT('BoxCheck.ico')
  #PROJECT('BoxEmpty.ico')
  #PROJECT('RadCheck.ico')
  #PROJECT('RadEmpty.ico')
#ENDAT
#ATSTART
  #ADD(%ModuleIncludeList, 'bitlist2.inc')
  #DECLARE(%JSBLControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #CASE(%ControlOriginal)
    #OF('?BitList')
      #SET(%JSBLControl,%Control)
    #ENDCASE
  #ENDFOR
#ENDAT
#TAB('The Bitlist Template')
#BOXED('')
#PROMPT('Class Name:',@s40),%JSBLClassName,Default('BLT::' & %ActiveTemplateInstance)
#DISPLAY('This is the label of the BitList class that you')
#DISPLAY('can use to reference the BitList in embedded code.')
#DISPLAY('(You can leave this as the default name if you wish.)')
#ENDBOXED
#BOXED('&Bitmap Variables')
#BUTTON('&Bitmap Variables'),MULTI(%JSBLBitMaps,%JSBLVariable & ' (' & %JSBLLabels & ')'),Inline
#BOXED('')
#PROMPT('Integer Variable to use:',FIELD),%JSBLVariable
#DISPLAY('This is the variable that contains the "BitSwitches"')
#DISPLAY('It normally would be a BYTE, SHORT, USHORT, LONG,')
#DISPLAY('or ULONG.')
#ENDBOXED
#BOXED('')
#PROMPT('Labels:',@s255),%JSBLLabels
#DISPLAY('This should be a string of words separated by ')
#DISPLAY('the PIPE character. Each of the words will serve ')
#DISPLAY('as a "Label" within the bitlist. To use a ')
#DISPLAY('VARIABLE, prepend the entry with an ')
#DISPLAY('exclamation mark.')
#ENDBOXED
#BOXED('')
#PROMPT('StartBit:',@S40),%JSBLStartBit,DEFAULT(0)
#DISPLAY('A number from zero to the total bits minus one. E.G.:')
#DISPLAY('A BYTE can range from 0 to 7')
#DISPLAY('SHORT and USHORT can range from 0 to 15')
#DISPLAY('LONG and ULONG can range from 0 to 31')
#DISPLAY('NOTE: You may use a BYTE variable here, but ')
#DISPLAY('do NOT prepend it with an exclamation mark!')
#ENDBOXED
#ENDBUTTON
#ENDBOXED
#ENDTAB
#TAB('Mutex')
#BOXED('Mutually Exclusive Bits')
#BUTTON('Mutex'),MULTI(%JSBLMutex,%JSBLMutex1 & ' - ' & %JSBLMutex2 & ' - ' & %JSBLMutexType & ' ' & Choose(%JSBLMutual=%True,'(Mutual)','')),Inline
#PROMPT('Mutex Row 1:',@n3),%JSBLMutex1
#PROMPT('Mutex Row 2:',@n3),%JSBLMutex2
#PROMPT('Mutex Type', OPTION),%JSBLMutexType
#PROMPT('Exclusive',RADIO)
#PROMPT('On',RADIO)
#PROMPT('Off',RADIO)
#BOXED(''),WHERE(%JSBLMutexType='Exclusive'),AT(,70)
#PROMPT('Allow De-selection',CHECK),%JSBLAllowClear,AT(10)
#DISPLAY('Most "Radio Buttons" don''t allow you to')
#DISPLAY('clear a value if one exists. If you want')
#DISPLAY('to enable this behavior, check this box.')
#ENDBOXED
#BOXED(''),WHERE(%JSBLMutexType<>'Exclusive'),AT(,70)
#PROMPT('Mutual',CHECK),%JSBLMutual,AT(10)
#DISPLAY('Means that no matter which row is "turned on"')
#DISPLAY('or "turned off", the related row will be turned')
#DISPLAY('on or off. Otherwise, only "Row 1" will do the work.')
#ENDBOXED
#BOXED(''),WHERE(%JSBLMutexType<>'Exclusive' AND %JSBLMutual=%True)
#PROMPT('Required',CHECK),%JSBLRequired,AT(10)
#DISPLAY('The "child" bit is required by the parent.')
#ENDBOXED
#ENDBUTTON
#ENDBOXED
#ENDTAB
#TAB('More...')
#BOXED('')
#PROMPT('Read Only',CHECK),%JSBLReadOnly,AT(10)
#DISPLAY('This means that the user cannot click on the ')
#DISPLAY('listbox to change the values.')
#ENDBOXED
#BOXED('')
#PROMPT('Allow Copy',CHECK),%JSBLAllowCopy,DEFAULT(1),AT(10)
#DISPLAY('If this is checked, the user can copy the ')
#DISPLAY('selected value to the clipboard. This can be ')
#DISPLAY('handy to have while in development.')
#ENDBOXED
#ENDTAB
#BOXED('')
#DISPLAY('Copyright  2000 J&&S Software Co.')
#DISPLAY('All Rights Reserved Worldwide')
#ENDBOXED
#DISPLAY('')
#AT(%DataSection)
%[20]JSBLClassName &BL2Class
#ENDAT
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(8400)
  %JSBLClassName &= NEW(BL2Class)
  %JSBLClassName.Init(%JSBLControl,%JSBLReadOnly,%JSBLAllowCopy,%WindowManager)
 #FOR(%JSBLMutex)
  %JSBLClassName.AddMutex(%JSBLMutex1,%JSBLMutex2,%(%BLTranslateType(%JSBLMutexType,%JSBLAllowClear,%JSBLRequired)),%JSBLMutual)
 #ENDFOR
 #FOR(%JSBLBitMaps)
  %JSBLClassName.AddItem(%JSBLVariable,%(%BLStripPling(%JSBLLabels)),%JSBLStartBit)!(*? BitMap,Byte BitCount=32,String Parms,Byte StartBit=0)
 #ENDFOR
#ENDAT
#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),PRIORITY(5050)
  If NOT %JSBLClassName &= NULL
    %JSBLClassName.Kill()
    Dispose(%JSBLClassName)
  end
#ENDAT
#AT(%ControlHandling,%JSBLControl),PRIORITY(500)
   If %JSBLClassName.TakeEvent() then Cycle.
#ENDAT
#AT(%WindowManagerMethodCodeSection,'Reset','(BYTE Force=0)'),PRIORITY(9000)
  %JSBLClassName.ReadBits()
#ENDAT
#GROUP(%BLStripPling,%Incoming)
  #DECLARE(%A)
  #IF(SUB(%Incoming,1,1)='!')
    #RETURN(SUB(%Incoming,2,LEN(%Incoming)-1))
  #ELSE
    #SET(%A,QUOTE(%Incoming))
    #RETURN( '''' & %A & '''' )
  #ENDIF
#GROUP(%BLTranslateType,%Incoming,%AllowClear,%Required)
  #CASE(%Incoming)
  #OF('Exclusive')
    #IF(%AllowClear)
      #Return('BLMutex:Exclusive+BLMutex:AllowClear')
    #ELSE
      #Return('BLMutex:Exclusive')
    #END  
  #OF('On')
    #IF(%Required)
      #Return('BLMutex:On+BLMutex:ParentOnReq')
    #ELSE
      #Return('BLMutex:On')
    #END  
  #OF('Off')
    #IF(%Required)
      #Return('BLMutex:Off+BLMutex:ParentOffReq')
    #ELSE  
      #Return('BLMutex:Off')
    #END  
  #ENDCASE