!**************************************************************************
!
!   Clarion source for PHP4CLARION demo
!
!   Rev     Date        Author              Details
!   =====================================================================
!   1.0     26/11/2002  V.Vahtera           Initial Creation
!
!**************************************************************************
  Program
  Include('winequ.clw')
  Map
! -------------------------------------------------------------------------
!                          WIN API PROTOTYPES
! -------------------------------------------------------------------------
    Module('Win Api')
      ! Console functions
      GetStdHandle(Ulong),Unsigned,Pascal,Name('GetStdHandle')
      ! SetStdHandle(Ulong,Unsigned),Bool,Pascal,Raw,Proc,Name('SetStdHandle')
      ! WriteConsole(Unsigned,Long,Dword,long,long),Bool,Pascal,Raw,Name('WriteConsoleA')
      ! ReadFile(Unsigned,*CSTRING,Ulong,*Ulong,<*OVERLAPPED>),Bool,Pascal,Raw,Name('ReadFile')
      WriteFile(Unsigned,*CSTRING,Ulong,*Ulong,<*OVERLAPPED>),Bool,Pascal,Raw,Name('WriteFile')
      ! GetLastError(),Ulong,Pascal,Raw
    . !end module
! -------------------------------------------------------------------------
!                     APPLICATION PROCEDURE PROTOTYPES
! -------------------------------------------------------------------------
      GetNames()
      StoreNames()
      SearchFields()
      WriteToConsole(String)
    . !end map

! -------------------------------------------------------------------------
!                      General Windows equates
! -------------------------------------------------------------------------
INVALID_HANDLE_VALUE            Equate(-1)
! -------------------------------------------------------------------------
!                      Console-specific Equates
! -------------------------------------------------------------------------
STD_INPUT_HANDLE                Equate(-10) ! Standard input and output handles
STD_OUTPUT_HANDLE               Equate(-11)
STD_ERROR_HANDLE                Equate(-12)
NULL                            Equate(0)
! -------------------------------------------------------------------------
!                          FOR WriteFile() API
! -------------------------------------------------------------------------
OVERLAPPED          Group,Type
Internal             Ulong
InternalHigh         Ulong
Offset               Ulong
OffsetHigh           Ulong
hEvent               Unsigned
                    END
Like:OVERLAPPED     Like(OVERLAPPED)
! -------------------------------------------------------------------------
!                          APPLICATION VARIABLES
! -------------------------------------------------------------------------
Retval              Ulong
hStdOut             Long
Argument            Cstring(10)
Command1            Cstring(10) ! Titles
Command2            Cstring(50) ! FirstName
Command3            Cstring(50) ! SurName
Command4            Cstring(50) ! Street
Command5            Cstring(10) ! House_No
Command6            Cstring(50) ! Town
Command7            Cstring(10) ! County
Command8            Cstring(10) ! PostCode
Command9            Cstring(50) ! Contact_Email
SearchField         Cstring(50) ! Search field

! For Writefile (console output)
lBytesWritten       Ulong
lBytesRead          Ulong
OutData1            Cstring(5000)
OutData2            Cstring(50)
! -------------------------------------------------------------------------
!                               FILE DRIVER
! -------------------------------------------------------------------------
cw_php              File,Driver('Topspeed'),Name('cw_php.tps'),Pre(Nam),Create,Thread
SurNameKey              Key(Nam:SurName),Dup
Record                  Record
Titles                     Cstring(10)
FirstName                  Cstring(50)
SurName                    Cstring(50)
Street                     Cstring(50)
House_No                   Cstring(10)
Town                       Cstring(50)
County                     Cstring(10)
PostCode                   Cstring(10)
Contact_Email              Cstring(50)
                        .. !end record & driver declaration

  Code

  hStdOut = GetStdHandle(STD_OUTPUT_HANDLE) !- I/O parms
  if hStdOut = INVALID_HANDLE_VALUE ; Message('Unable to get STD_OUTPUT_HANDLE') ! troubles
  . !end if
                           ! First argument Command('1') is holding the operation instruction(s)
  if ~Command('/PHP') Then ! did we get a proper identification?

    Loop x# = 1 To 50          ! Get first 50 arguments
       Argument = Command(x#)  ! get argument
       If Argument             ! is there anything
           ArgumentCount# += 1 ! how many arguments we have counted
           OutData1 = OutData1 & 'Argument' & x# & ' : ' & Argument & '<13,10>'
       Else
           Break ! no more arguments
       . ! end if
    . ! end loop
          OutData2 = 'Number of arguments: ' & ArgumentCount# & '<13,10>'
          OutData1 = OutData2 & OutData1 & '<13,10>'
          WriteToConsole(OutData1)
    Return ! Just in case the exe is not called by PHP script, it doesn't hang around forever.
  . !end if

  Case Command('2')
  Of 'PUT'
    Command1 = Command('3')  ! Titles
    Command2 = Command('4')  ! FirstName
    Command3 = Command('5')  ! SurName
    Command4 = Command('6')  ! Street
    Command5 = Command('7')  ! House_No
    Command6 = Command('8')  ! Town
    Command7 = Command('9')  ! County
    Command8 = Command('10') ! PostCode
    Command9 = Command('11') ! Contact_Email

    StoreNames()     ! add the record
  Of 'GET'
    GetNames()       ! go get all the records
  Of 'SEARCH'
    SearchField = Command('3')  ! Search for
    SearchFields()              ! go find a match for the search
  . !end case

! -------------------------------------------------------------------------
!                           GetNames Procedure
! -------------------------------------------------------------------------
GetNames Procedure()

 Code

 OutData1 = 'RECORD(S) FROM cw_php.tps FILE:' & '<13,10>'
 Open(cw_php)
 If ErrorCode() Then
    OutData1 = '<13,10>' & 'There was an error: ' & ErrorCode() & ' opening the cw_php.tps file'
    WriteToConsole(OutData1)
 . !end if error

 Set(Nam:SurNameKey)
 Loop
    Next(cw_php)
    If ErrorCode() Then Break. ! break on end of file

    OutData1 = OutData1   & '<13,10>' & |
      Nam:Titles          & '<13,10>' & |
      Nam:FirstName       & '<13,10>' & |
      Nam:SurName         & '<13,10>' & |
      Nam:Street          & '<13,10>' & |
      Nam:House_No        & '<13,10>' & |
      Nam:Town            & '<13,10>' & |
      Nam:County          & '<13,10>' & |
      Nam:PostCode        & '<13,10>' & |
      Nam:Contact_Email   & '<13,10>'

 . ! end loop

 Close(cw_php)
 WriteToConsole(OutData1) ! return records to the PHP script

! -------------------------------------------------------------------------
!                           StoreNames Procedure
! -------------------------------------------------------------------------
StoreNames Procedure()

 Code

 Open(cw_php) ; If ErrorCode() Then ; Create(cw_php) ; Open(cw_php)
 . !end if error

 Nam:Titles        = Clip(Command1)
 Nam:FirstName     = Clip(Command2)
 Nam:SurName       = Clip(Command3)
 Nam:Street        = Clip(Command4)
 Nam:House_No      = Clip(Command5)
 Nam:Town          = Clip(Command6)
 Nam:County        = Clip(Command7)
 Nam:PostCode      = Clip(Command8)
 Nam:Contact_Email = Clip(Command9)

 Add(cw_php) ! add record
 If ErrorCode() Then
    OutData1 = '<13,10>' & 'There was an error: ' & ErrorCode() & ' adding the record'
    WriteToConsole(OutData1)
    Close(cw_php)
 Else
    Close(cw_php)
    OutData1 = '<13,10>' & 'Record added'
    WriteToConsole(OutData1)
 . !end if error

! -------------------------------------------------------------------------
!                         SearchFields Procedure
! -------------------------------------------------------------------------
SearchFields Procedure()

 Code

 OutData1 = 'RECORD(S) FOUND FROM cw_php.tps FILE:' & '<13,10>'
 Open(cw_php)
 If ErrorCode() Then
    OutData1 = '<13,10>' & 'There was an error: ' & ErrorCode() & ' opening the cw_php.tps file'
    WriteToConsole(OutData1)
 . !end if error

 Set(Nam:SurNameKey)
 Loop
    Next(cw_php)
    Found# = 0
    If ErrorCode() Then Break . ! break on end of the file
    ! Look for match on each field in cw_php.tps -->
    If    Upper(SearchField) = Upper(Nam:Titles)        ; Found# = 1 ! Compare search string against
    ElsIf Upper(SearchField) = Upper(Nam:FirstName)     ; Found# = 1 ! against each record entry
    ElsIf Upper(SearchField) = Upper(Nam:SurName)       ; Found# = 1
    ElsIf Upper(SearchField) = Upper(Nam:Street)        ; Found# = 1
    ElsIf Upper(SearchField) = Upper(Nam:House_No)      ; Found# = 1
    ElsIf Upper(SearchField) = Upper(Nam:Town)          ; Found# = 1
    ElsIf Upper(SearchField) = Upper(Nam:County)        ; Found# = 1
    ElsIf Upper(SearchField) = Upper(Nam:PostCode)      ; Found# = 1
    Elsif Upper(SearchField) = Upper(Nam:Contact_Email) ; Found# = 1
    Else
    . !end if

    If Found#              ! We have found a match so return this particular record
          TotalFound# += 1 ! increase number of found matches
          OutData1 = OutData1 & '<13,10>' & Nam:Titles
          OutData1 = OutData1 & '<13,10>' & Nam:FirstName
          OutData1 = OutData1 & '<13,10>' & Nam:SurName
          OutData1 = OutData1 & '<13,10>' & Nam:Street
          OutData1 = OutData1 & '<13,10>' & Nam:House_No
          OutData1 = OutData1 & '<13,10>' & Nam:Town
          OutData1 = OutData1 & '<13,10>' & Nam:County
          OutData1 = OutData1 & '<13,10>' & Nam:PostCode
          OutData1 = OutData1 & '<13,10>' & Nam:Contact_Email & '<13,10>'
    . !end if
 . ! end loop

         OutData1 = OutData1 & '<13,10>' & 'Total hits: ' & TotalFound# & '<13,10><13,10>'

 If Not TotalFound# ! Nothing found
     OutData1 = 'No match for: <<b>' & SearchField & '<</b><13,10>'
 . !end if

 Close(cw_php)
 WriteToConsole(OutData1) ! return found record(s) to the PHP script
! -------------------------------------------------------------------------
!                        WriteToConsole Procedure
! -------------------------------------------------------------------------
WriteToConsole Procedure(String pTextToWrite)
ConsoleText    Cstring(5000)

 Code

 ConsoleText = Clip(pTextToWrite)
 Retval = WriteFile(hStdOut,ConsoleText,LEN(ConsoleText),lBytesWritten,Like:OVERLAPPED)