    program
    map
MessageTest     PROCEDURE
WindowTest      PROCEDURE
LoopTest      PROCEDURE
ShowKeyState    PROCEDURE(STRING MsgTitle),LONG,PROC
    .

KeyState:Shift         EQUATE(0100h)    !Shift key is pressed
KeyState:Ctrl          EQUATE(0200h)    !Ctrl key is pressed
KeyState:Alt           EQUATE(0400h)    !Alt key is pressed
KeyState:EnterOnNum    EQUATE(0800h)    !Num Pad Enter Key, n/a with Message()
KeyState:CapsLock      EQUATE(1000h)    !Caps Lock is On
KeyState:NumLock       EQUATE(2000h)    !Num Lock is On
KeyState:ScrollLock    EQUATE(4000h)    !Scroll Lock is On
KeyState:InsertKey     EQUATE(8000h)    !Insert Mode is On, Off is Overwrite


AppFrame APPLICATION('KeyState Test'),AT(,,400,200),FONT('MS Sans Serif',8,,FONT:regular),STATUS(30,30,30,30,30,30,30,30,-1), |
         SYSTEM,RESIZE,TIMER(2)
       MENUBAR
         MENU('Keystate'),USE(?Keystate)
           ITEM('Test with Message'),USE(?KeystateTestwithMessage)
           ITEM('Test with Window'),USE(?KeystateTestwithWindow)
           ITEM('Loop Test'),USE(?LoopTest)
           ITEM,SEPARATOR
           ITEM('Menu Item Keypress Test'),USE(?KeystateMenuItemKeypressTest)
         END
         ITEM('Exit!'),USE(?Exit),STD(Std:Close)
       END
     END


    CODE

    OPEN(AppFrame)
    ACCEPT
        CASE ACCEPTED()
        OF ?KeystateTestwithMessage    ;     MessageTest
        OF ?KeystateTestwithWindow     ;     START(WindowTest)
        OF ?LoopTest                   ;     LoopTest
        OF ?KeystateMenuItemKeypressTest    ;     ShowKeyState('Menu Item Test')
        END
        CASE EVENT()
        OF EVENT:Timer
             AppFrame{PROP:StatusText,1} = CHOOSE(~BAND(KEYSTATE(), KeyState:Shift ),'','Shift')
             AppFrame{PROP:StatusText,2} = CHOOSE(~BAND(KEYSTATE(), KeyState:Ctrl ),'','Ctrl') 
             AppFrame{PROP:StatusText,3} = CHOOSE(~BAND(KEYSTATE(), KeyState:Alt ),'','Alt') 
             !AppFrame{PROP:StatusText,3} = CHOOSE(~BAND(KEYSTATE(), KeyState:EnterOnNum ),'','eNum')
             AppFrame{PROP:StatusText,5} = CHOOSE(~BAND(KEYSTATE(), KeyState:CapsLock ),'','Cap')
             AppFrame{PROP:StatusText,6} = CHOOSE(~BAND(KEYSTATE(), KeyState:NumLock ),'','Num')
             AppFrame{PROP:StatusText,7} = CHOOSE(~BAND(KEYSTATE(), KeyState:ScrollLock ),'','Scrl') 
             AppFrame{PROP:StatusText,8} = CHOOSE(~BAND(KEYSTATE(), KeyState:InsertKey ),'Ovr','Ins')
        END
    END



MessageTest     PROCEDURE

    CODE

    LOOP
        IF ShowKeyState('Message') THEN BREAK.
!        K = KEYSTATE()
!
!        KM = '|' & |
!                '|Shift = ' & CHOOSE(~BAND(K, KeyState:Shift ),'Off','ON') & |
!                '|Ctrl = ' & CHOOSE(~BAND(K, KeyState:Ctrl ),'Off','ON') & |
!                '|Alt = ' & CHOOSE(~BAND(K, KeyState:Alt ),'Off','ON') & |
!                '|EnterOnNum = ' & CHOOSE(~BAND(K, KeyState:EnterOnNum ),'Off','ON') & |
!                '|CapsLock = ' & CHOOSE(~BAND(K, KeyState:CapsLock ),'Off','ON') & |
!                '|NumLock = ' & CHOOSE(~BAND(K, KeyState:NumLock ),'Off','ON') & |
!                '|ScrollLock = ' & CHOOSE(~BAND(K, KeyState:ScrollLock ),'Off','ON') & |
!                '|InsertKey = ' & CHOOSE(~BAND(K, KeyState:InsertKey ),'Off','ON') & |
!                '|'
!
!
!        CASE MESSAGE('KeyState = '&K&|
!             '||'&CLIP(KM)&|
!             '||Set your Keys and then press OK.', |
!             'KeyState', ICON:Asterisk, |
!              BUTTON:OK+BUTTON:Cancel, BUTTON:OK, 0)
!        OF BUTTON:OK
!        OF BUTTON:Cancel
!            BREAK
!        END !CASE
    END



WindowTest      PROCEDURE

Window WINDOW('KeyState Window Test'),AT(,,185,92),FONT('MS Sans Serif',8,,FONT:regular),SYSTEM,GRAY
       BUTTON('OK'),AT(144,10,35,14),USE(?OkButton),DEFAULT
     END


    CODE
    OPEN(Window)
    ACCEPT
        CASE EVENT()
        OF EVENT:Accepted
           IF ShowKeyState('EVENT:Accepted') THEN BREAK.
       END

    END



ShowKeyState    PROCEDURE(STRING MsgTitle)  !,LONG

K       LONG
KM      STRING(10000)
Ret     LONG

    CODE

           K = KEYSTATE()

           KM = '|' & |
                   '|Shift = ' & CHOOSE(~BAND(K, KeyState:Shift ),'Off','ON') & |
                   '|Ctrl = ' & CHOOSE(~BAND(K, KeyState:Ctrl ),'Off','ON') & |
                   '|Alt = ' & CHOOSE(~BAND(K, KeyState:Alt ),'Off','ON') & |
                   '||EnterOnNum = ' & CHOOSE(~BAND(K, KeyState:EnterOnNum ),'Off','ON (Key Num Pad)') & |
                   '|CapsLock = ' & CHOOSE(~BAND(K, KeyState:CapsLock ),'Off','ON') & |
                   '|NumLock = ' & CHOOSE(~BAND(K, KeyState:NumLock ),'Off','ON') & |
                   '|ScrollLock = ' & CHOOSE(~BAND(K, KeyState:ScrollLock ),'Off','ON') & |
                   '||InsertKey = ' & CHOOSE(~BAND(K, KeyState:InsertKey ),'Off (Overwrite)','ON (Insert)') & |
                   '|'


           CASE MESSAGE('KeyState = '&K&|
                '||'&CLIP(KM)&|
                '||Set your Keys and then press OK.', |
                'KeyState: ' & MsgTitle , ICON:Asterisk, |
                 BUTTON:OK+BUTTON:Cancel, BUTTON:OK, 0)
           OF BUTTON:OK
           OF BUTTON:Cancel
               Ret = 1
           END !CASE

           RETURN(Ret)

LoopTest      PROCEDURE !Keystate is updated on in Accept, Message
Idx     LONG,AUTO
    CODE
    Message('Press OK to start loop.|Press Shift to stop loop','Loop Test')
    LOOP Idx = 1 TO 1000000
         IF BAND(KEYSTATE(),Keystate:Shift)
            Message('Never see this after 1||Idx=' & Idx )
         END
    END
    ShowKeyState('Loop All Done')


 OMIT('--example code--')

    LOOP WHILE EXISTS('Payables.sem')
         MESSAGE('You must process Payables first!')
         IF ~BAND(KEYSTATE(), Keystate:Ctrl+Keystate:Shift) THEN RETURN(0).
         REMOVE('Payables.sem')
    END


 !OMIT('--example code--')

