!
! This is the intellectual property of Konrad Byers - Copyright 2002
! All rights reserved worldwide
!
! This template must not be copied, or modified, in part or whole, or distributed in any
! way, other than by the author Konrad Byers.
!
! No warranty of any kind is expressed, or implied; use only at your own risk.
!
! Contact Konrad@eSoftAnywhere.com / ve1exe@rac.ca for additional information
!
!

!Any Ascii File Read/Write - Class definitions

!ABCIncludeFile(ABC)

OMIT('_EndOfInclude_',_ANYASCIIPRESENT_)
_ANYASCIIPRESENT_   EQUATE(1)

 INCLUDE('ABError.inc'),ONCE
 INCLUDE('ABUtil.INC'),ONCE

ANYASCII_IO_SIZE EQUATE(64000)

 ITEMIZE,PRE(ANYASCIIFILTER)
BooleanExpression    EQUATE
FilterExpression     EQUATE
 END


AnyAsciiFileClass   CLASS,TYPE,MODULE('AnyAscii.clw'),LINK('AnyAscii.clw',_ABCLinkMode_),DLL(_ABCDllMode_)

Errors                 &ErrorClass, PROTECTED
DefaultErrors          &ErrorClass, PRIVATE
LastError              USHORT(0), PROTECTED
RecordGroup            &GROUP, PROTECTED
FieldSeperator         CSTRING(2), PROTECTED
FieldEnclosure         CSTRING(2), PROTECTED
ClipFields             BYTE(False), PROTECTED
FileName               CSTRING(FILE:MaxFilePath+FILE:MaxFileName+1), PROTECTED
CurrentFileName        CSTRING(FILE:MaxFilePath+FILE:MaxFileName+1), PROTECTED
Create                 BYTE(True)
OpenMode               ULONG(ReadWrite+DenyWrite), PROTECTED
CurrentOpenMode        ULONG(0), PROTECTED
FileOpened             BYTE(False), PROTECTED
ReadPosition           ULONG(1), PROTECTED
PreviousReadPosition   ULONG(0), PROTECTED
PreviousReadBytes      ULONG(0), PROTECTED
AutoFlush              BYTE(False), PROTECTED
CtrlZ                  ANY, PROTECTED
EndOfRecord            ANY, PROTECTED
Tab                    ANY, PROTECTED
WriteHeaderRecord      BYTE(False), PROTECTED
WroteHeaderRecord      BYTE(False), PROTECTED
ProcessHeaderRecord    BYTE(False), PROTECTED
IgnoreHeaderRecord     BYTE(False), PROTECTED
RecordFilter           ANY, PROTECTED
FieldNames             &FieldNamesType, PROTECTED
cTextLine              CSTRING(ANYASCII_IO_SIZE+1), PROTECTED

Construct              PROCEDURE, PROTECTED
Destruct               PROCEDURE, PROTECTED
Init                   PROCEDURE(<ErrorClass EC>), VIRTUAL
SetRecordLayout        PROCEDURE(*GROUP RecordGroup, <STRING FieldSeperator>, <STRING FieldEnclosure>), BYTE, PROC, VIRTUAL
SetFieldName           PROCEDURE(*GROUP RecordGroup, *ANY Field, STRING FieldName),VIRTUAL
SetFieldNumber         PROCEDURE(*GROUP RecordGroup, *ANY Field, USHORT FieldNumber),VIRTUAL
SetField               PROCEDURE(*GROUP RecordGroup, *ANY Field, *ANY FieldProp, *ANY FieldValue),VIRTUAL
ClearFields            PROCEDURE(<*GROUP RecordGroup>),VIRTUAL
SetWriteHeaderRecord   PROCEDURE(BYTE WriteHeaderRecord),VIRTUAL
SetProcessHeaderRecord PROCEDURE(BYTE WriteHeaderRecord),VIRTUAL
SetIgnoreHeaderRecord  PROCEDURE(BYTE WriteHeaderRecord),VIRTUAL
SetRecordFilter        PROCEDURE(STRING RecordFilter, BYTE FilterType=ANYASCIIFILTER:BooleanExpression),VIRTUAL
ValidateRecord         PROCEDURE(),BYTE,VIRTUAL
PopulateRecord         PROCEDURE(BYTE HandleError), PROTECTED, BYTE, PROC, VIRTUAL
UnpopulateRecord       PROCEDURE(BYTE HandleError), PROTECTED, BYTE, VIRTUAL
ProcessHeaderFields    PROCEDURE(), PROTECTED
TryOpen                PROCEDURE(<STRING AsciiFileName>, <ULONG OpenMode>), BYTE, PROC, VIRTUAL
Open                   PROCEDURE(<STRING AsciiFileName>, <ULONG OpenMode>), BYTE, PROC, VIRTUAL
TryOpenExisting        PROCEDURE(<STRING AsciiFileName>, <ULONG OpenMode>), BYTE, PROC, VIRTUAL
OpenExisting           PROCEDURE(<STRING AsciiFileName>, <ULONG OpenMode>), BYTE, PROC, VIRTUAL
TryCreateFile          PROCEDURE(<STRING AsciiFileName>, <ULONG OpenMode>), BYTE, PROC, VIRTUAL
CreateFile             PROCEDURE(<STRING AsciiFileName>, <ULONG OpenMode>), BYTE, PROC, VIRTUAL
TryOpenOrCreate        PROCEDURE(<STRING AsciiFileName>, <ULONG OpenMode>), BYTE, PROC, VIRTUAL
OpenOrCreate           PROCEDURE(<STRING AsciiFileName>, <ULONG OpenMode>), BYTE, PROC, VIRTUAL
TryNext                PROCEDURE(ULONG ReadPosition=0), BYTE, PROC, VIRTUAL
Next                   PROCEDURE(ULONG ReadPosition=0), BYTE, PROC, VIRTUAL
TryNext                PROCEDURE(*CSTRING TextLine, ULONG ReadPosition=0), BYTE, PROC, VIRTUAL
Next                   PROCEDURE(*CSTRING TextLine, ULONG ReadPosition=0), BYTE, PROC, VIRTUAL
TryNext                PROCEDURE(*STRING TextLine,  ULONG ReadPosition=0), BYTE, PROC, VIRTUAL
Next                   PROCEDURE(*STRING TextLine,  ULONG ReadPosition=0), BYTE, PROC, VIRTUAL
TryNext                PROCEDURE(*PSTRING TextLine, ULONG ReadPosition=0), BYTE, PROC, VIRTUAL
Next                   PROCEDURE(*PSTRING TextLine, ULONG ReadPosition=0), BYTE, PROC, VIRTUAL
NextInternal           PROCEDURE(ULONG ReadPosition=0, BYTE HandleError), BYTE, PROC, VIRTUAL
TryUpdate              PROCEDURE(), BYTE, PROC, VIRTUAL
Update                 PROCEDURE(), BYTE, PROC, VIRTUAL
TryUpdate              PROCEDURE(STRING TextLine), BYTE, PROC, VIRTUAL
Update                 PROCEDURE(STRING TextLine), BYTE, PROC, VIRTUAL
UpdateInternal         PROCEDURE(BYTE HandleError), BYTE, PRIVATE
TryInsert              PROCEDURE(), BYTE, PROC, VIRTUAL
Insert                 PROCEDURE(), BYTE, PROC, VIRTUAL
TryInsert              PROCEDURE(STRING TextLine), BYTE, PROC, VIRTUAL
Insert                 PROCEDURE(STRING TextLine), BYTE, PROC, VIRTUAL
InsertInternal         PROCEDURE(BYTE HandleError), BYTE, PRIVATE
SetName                PROCEDURE(STRING FileName), VIRTUAL
GetName                PROCEDURE(), STRING, VIRTUAL
GetOpenName            PROCEDURE(), STRING, VIRTUAL
IsOpen                 PROCEDURE(), BYTE, VIRTUAL
Position               PROCEDURE(), ULONG, VIRTUAL
SetPosition            PROCEDURE(ULONG ReadPosition), ULONG, VIRTUAL
InsertPosition         PROCEDURE(), ULONG, VIRTUAL
Close                  PROCEDURE(), VIRTUAL
CheckFileOpened        PROCEDURE(BYTE HandleError), BYTE, PROC, PRIVATE
SetAutoFlush           PROCEDURE(BYTE AutoFlush), VIRTUAL
SetCtrlZ               PROCEDURE(BYTE OnOff), VIRTUAL
SetEndOfRecord         PROCEDURE(STRING EndOfRecord),VIRTUAL
SetTab                 PROCEDURE(SHORT Spaces=-100),VIRTUAL
SetClipFields          PROCEDURE(BYTE ClipFields), VIRTUAL
FileStatusCurrent      PROCEDURE(), BYTE, PROTECTED
InitFile               PROCEDURE(<STRING AsciiFileName>, BYTE CreateFile=False, LONG OpenMode=ReadWrite+DenyWrite, BYTE HandleError), BYTE, PROC, PROTECTED
SetError               PROCEDURE(USHORT Number), VIRTUAL
GetError               PROCEDURE(),SIGNED, VIRTUAL
Throw                  PROCEDURE(USHORT ErrorNumber), BYTE, PROC, VIRTUAL
Throw                  PROCEDURE(), BYTE, PROC, VIRTUAL
ThrowMessage           PROCEDURE(USHORT ErrorNumber, STRING Text), BYTE, PROC, VIRTUAL

                    END

  _EndOfInclude_



