#TEMPLATE(BitListClass,'J&S Bitlist Template'),FAMILY('ABC')
#!-----------------------------------------------------------------------------!
#! J&S BitList Class .9912
#! Template
#! Copyright (c) 1999 by J&S Software Co. (jeff@jssoftware.com)
#!-----------------------------------------------------------------------------!
#! The in-column tagging method as well as the icons have been
#! borrowed (with permission) from Mike Hanson's SuperTagging templates.
#!-----------------------------------------------------------------------------!
#!The contents of this file are subject to the CoveComm Inc. Developers Open 
#!Source Public License Version 1.0 (the "License"); you may not use this 
#!product except in compliance with the License. You may obtain a copy of 
#!the License at http://www.clarionmag.com/common/dospl.html. Software
#!distributed under the License is distributed on an "AS IS" basis, WITHOUT 
#!WARRANTY OF ANY KIND, either express or implied. See the License for the 
#!specific language governing rights and limitations under the License. 
#!The Original Code is Copyright (c) by J&S Software Co., released
#!June 28, 1999. The Initial Developer of the Original Code is Jeff Slarve. 
#!-----------------------------------------------------------------------------!
#! Synopsis
#!
#! A quick and easy interface to the 32-bits available within a LONG integer.
#! Allows the developer to quickly label each bit and present it to the user
#! in the form of a psuedo "check box" instead of declaring a BYTE variable
#! and populating a CHECK control for each switch.
#!
#! The number of records displayed in the listbox are dictated by two things:
#!    1. The StartingBit
#!    2. The number of items passed in the PARMS parameter of the INIT() method.
#!
#!-----------------------------------------------------------------------------!
#CONTROL(Bitlist,'Bitlist Control'),MULTI
   CONTROLS
     LIST,AT(,,100,50),USE(?BitList),NOBAR,VSCROLL,FORMAT('11C|I@s1@500L(2)@s60@')
   END
#AT(%CustomGlobalDeclarations)
  #PROJECT('BoxCheck.ico')
  #PROJECT('BoxEmpty.ico')
#ENDAT
#ATSTART
  #ADD(%ModuleIncludeList, 'bitlist.inc')
  #DECLARE(%JSBLControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #CASE(%ControlOriginal)
    #OF('?BitList')
      #SET(%JSBLControl,%Control)
    #ENDCASE
  #ENDFOR
#ENDAT
#TAB('The Bitlist Template')
#BOXED('')
#PROMPT('Class Name:',@s40),%JSBLClassName,Default('BLT::' & %ActiveTemplateInstance)
#DISPLAY('This is the label of the BitList class that you')
#DISPLAY('can use to reference the BitList in embedded code.')
#DISPLAY('(You can leave this as the default name if you wish.)')
#ENDBOXED
#BOXED('')
#PROMPT('LONG Variable to use:',FIELD),%JSBLVariable
#DISPLAY('This is the variable that contains the "BitSwitches"')
#ENDBOXED
#BOXED('')
#PROMPT('Labels:',@s255),%JSBLLabels
#DISPLAY('This should be a string of words separated by ')
#DISPLAY('the PIPE character. Each of the words will serve ')
#DISPLAY('as a "Label" within the bitlist. To use a ')
#DISPLAY('VARIABLE, prepend the entry with an ')
#DISPLAY('exclamation mark.')
#ENDBOXED
#ENDTAB
#TAB('More...')
#BOXED('')
#BOXED('')
#PROMPT('StartBit:',@S40),%JSBLStartBit,DEFAULT(0)
#DISPLAY('This should be a number from 0 to 31.')
#DISPLAY('NOTE: You may use a BYTE variable here, but ')
#DISPLAY('do NOT prepend it with an exclamation mark!')
#ENDBOXED
#BOXED('')
#PROMPT('Read Only',CHECK),%JSBLReadOnly,AT(10)
#DISPLAY('This means that the user cannot click on the ')
#DISPLAY('listbox to change the values.')
#ENDBOXED
#BOXED('')
#PROMPT('Allow Copy',CHECK),%JSBLAllowCopy,DEFAULT(1),AT(10)
#DISPLAY('If this is checked, the user can copy the ')
#DISPLAY('selected value to the clipboard. This can be ')
#DISPLAY('handy to have while in development.')
#ENDBOXED
#ENDBOXED
#ENDTAB
#BOXED('')
#DISPLAY('Copyright  1999 J&&S Software Co.')
#DISPLAY('All Rights Reserved Worldwide')
#ENDBOXED
#DISPLAY('')
#AT(%DataSection)
%[20]JSBLClassName &BLClass
#ENDAT
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(8400)
  %JSBLClassName &= NEW(BLClass)
  %JSBLClassName.Init(%JSBLVariable,%(%BLStripPling(%JSBLLabels)),%JSBLControl,%JSBLStartBit,%JSBLReadOnly,%JSBLAllowCopy,%WindowManager)
#ENDAT
#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),PRIORITY(5050)
  If NOT %JSBLClassName &= NULL
    %JSBLClassName.Kill()
    Dispose(%JSBLClassName)
  end
#ENDAT
#AT(%ControlHandling,%JSBLControl),PRIORITY(500)
   If %JSBLClassName.TakeEvent() then Cycle.
#ENDAT
#AT(%WindowManagerMethodCodeSection,'Reset','(BYTE Force=0)'),PRIORITY(9000)
  %JSBLClassName.ReadBits()
#ENDAT
#GROUP(%BLStripPling,%Incoming)
  #DECLARE(%A)
  #IF(SUB(%Incoming,1,1)='!')
    #RETURN(SUB(%Incoming,2,LEN(%Incoming)-1))
  #ELSE
    #SET(%A,QUOTE(%Incoming))
    #RETURN( '''' & %A & '''' )
  #ENDIF

