 Member
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

 Map
   !Local Procedures, if any, go here
   !API Prototypes
   !Module('api')
   !  Include('FldMgrCl.PRO')
   !End
 end

!Includes this class and others
 include('FldMgrCl.inc')

!global data for this module
Return:Benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)

!-------------------------------------------------------------
!---Start of FldMgrClType class
!-------------------------------------------------------------
FldMgrClType.Init                  Procedure()
  Code
  SELF.FieldListQ &= New FieldListQType
  Assert(~SELF.FieldListQ &= NULL)
  SELF.KeyQ &= New KeyQType
  Return

FldMgrClType.Kill              Procedure()
!destroy any dynamic objects and clean up
Recs long,auto         !junk queue record count
I    long,auto         !junk index variable
    Code
    !Null the ANYs in the FieldHdrList then then dispose of the Q
    If ~SELF.FieldListQ &= NULL Then
      Recs = Records(SELF.FieldListQ)
      Loop I = 1 to Recs
        Get(SELF.FieldListQ,I)
        SELF.FieldListQ.FieldRef  &= NULL
        Put(SELF.FieldListQ)
      End
      Dispose(SELF.FieldListQ)
    End
    If ~SELF.KeyQ&=NULL then Dispose(SELF.KeyQ).
    RETURN

FldMgrClType.AddFile        Procedure(File pFile, *Group pBuffer)
  code
  SELF.File &= pFile
  SELF.Buffer &= pBuffer
  Return

FldMgrClType.AddField       Procedure(String pFieldName, *? pField)
  code
  Assert(~SELF.FieldListQ&=NULL)
  Clear(SELF.FieldListQ)
  SELF.FieldListQ.FieldRef &= pField
  SELF.FieldListQ.FieldName = Upper(pFieldName)
  ADD(SELF.FieldListQ,SELF.FieldListQ.FieldName)
  Return

FldMgrClType.AddManagers  Procedure(FileManager pFM, RelationManager pRM)
  code
  SELF.FM &= pFM
  SELF.RM &= pRM
  Return

FldMgrClType.AddKey     Procedure(string pKeyName, Key pKey)
  code
  Assert(~SELF.KEYQ&=NULL)
  SELF.KeyQ.KeyName = Upper(pKeyName)
  SELF.KeyQ.TheKey  &= pKey
  Add(SELF.KEYQ,SELF.KeyQ.KeyName)
  Return

FldMgrClType.AliasField          Procedure(String pFieldName, string pAliasName)
TempAny Any
  code
  Assert(~SELF.FieldListQ&=NULL)
  SELF.FieldListQ.FieldName = Upper(pFieldName)
  Get(SELF.FieldListQ,SELF.FieldListQ.FieldName)
  Assert(Errorcode()=0)
  TempAny &= SELF.FieldListQ.FieldRef   !Save the reference
  Clear(SELF.FieldListQ)                !Clear the queue
  SELF.FieldListQ.FieldName = upper(pAliasName)    !Setup the two fields and add
  SELF.FieldListQ.FieldRef &= TempAny
  TempAny &=NULL
  ADD(SELF.FieldListQ,SELF.FieldListQ.FieldName)
  Assert(Errorcode()=0)
  Return

FldMgrClType.AliasKey            Procedure(String pKeyName, String pAliasName)
  code
  Assert(~SELF.KEYQ&=NULL)
  SELF.KeyQ.KeyName = Upper(pKeyName)
  get(SELF.KeyQ,SELF.KeyQ.KeyName)
  Assert(Errorcode()=0)
  SELF.keyQ.KeyName=Upper(pAliasName)
  Add(SELF.KEYQ,SELF.KeyQ.KeyName)
  Assert(Errorcode()=0)
  Return


FldMgrClType.Insert     Procedure(byte handleErrors=0) !,byte
  code
  Assert(~SELF.FM&=NULL)
  If HandleErrors then
    Return(SELF.FM.Insert())
  Else
    Return(SELF.FM.TryInsert())
  end

FldMgrClType.Update     Procedure() !,byte
  code
  Assert(~SELF.RM&=NULL)
  Return(SELF.RM.Update(0))

FldMgrClType.Delete     procedure(byte pAskFirst=0) !,byte
  code
  Assert(~SELF.RM&=NULL)
  Return(SELF.Rm.Delete(pAskFirst))

FldMgrClType.SetField       Procedure(String pFieldName)
  code
  Assert(~SELF.FieldListQ&=NULL)
  SELF.FieldListQ.FieldName = Upper(pFieldName)
  Get(SELF.FieldListQ,SELF.FieldListQ.FieldName)
  !Assert(ErrorCode()=0)
  If Errorcode() then message('Error locating field:'&clip(pfieldName)&' Error:'&Clip(Error()),'SetFieldError').

  Return


FldMgrclType.SetField       Procedure(String pFieldName, ? pTheValue)
  Code
  SELF.FieldListQ.FieldName = Upper(pFieldName)
  Get(SELF.FieldListQ,SELF.FieldListQ.FieldName)
!  Assert(ErrorCode()=0)
  If ~Errorcode() then
    SELF.FieldListQ.FieldRef = pTheValue
  else
    If Errorcode() then message('Error locating field:'&clip(pfieldName)&' Error:'&Clip(Error()),'SetFieldError').
  end
  Return

FldMgrclType.SetField       Procedure(String pFieldName, *Cstring pTheValue)
  Code
  Assert(~SELF.FieldListQ&=NULL)
  SELF.FieldListQ.FieldName = Upper(pFieldName)
  Get(SELF.FieldListQ,SELF.FieldListQ.FieldName)
!  Assert(ErrorCode()=0)
  If ~Errorcode() then
    SELF.FieldListQ.FieldRef = pTheValue
  else
    If Errorcode() then message('Error locating field:'&clip(pfieldName)&' Error:'&Clip(Error()),'SetFieldError').
  end
  Return

FldMgrClType.GetField       Procedure(String pFieldName)
  code
    Assert(~SELF.FieldListQ&=NULL)
  SELF.FieldListQ.FieldName = Upper(pFieldName)
  Get(SELF.FieldListQ,SELF.FieldListQ.FieldName)
  !If Errorcode() then Message('Get Field error: '& pFieldName).
  Assert(ErrorCode()=0)
  Return SELF.FieldListQ.FieldRef




FldMgrClType.ClearBuffer    Procedure()
  Code
  Assert(~SELF.Buffer&=NULL)
  Clear(SELF.Buffer)
  Return

FldMgrClType.Fetch          Procedure(string pKeyName)!,byte,proc
  Code
  Assert(~SELF.KeyQ&=NULL)
  SELF.KeyQ.KeyName = Upper(pKeyName)
  Get(SELF.KeyQ,SELF.KeyQ.Keyname)
  If Errorcode() then SELF.Clearbuffer;Return(Return:Fatal).
  Assert(~SELF.FM&=NULL)
  Return(SELF.FM.TryFetch(SELF.KeyQ.TheKey))

FldMgrClType.SetFile       Procedure()!,byte,proc
   code
   Assert(~SELF.File&=Null)
   Set(SELF.File)
   Return(Choose(Errorcode()=0,0,3))

FldMgrClType.SetKey        Procedure(String pKeyName,<String pKeyName2>) !byte,proc
OtherKey &Key
   code
   Assert(~SELF.KeyQ&=NULL)
   If ~Omitted(3) then
     SELF.KeyQ.KeyName = Upper(pKeyName2)
     Get(SELF.keyQ, SELF.KeyQ.KeyName)
     If Errorcode() then
       Message('Assert finding key2 in FieldMgr Set: ' & pkeyName2,'Set Assert')
       Return(Return:Fatal)
     end
     OtherKey &= SELF.KeyQ.TheKey
   End

   SELF.KeyQ.KeyName = Upper(pKeyName)
   Get(SELF.KeyQ, SELF.KeyQ.KeyName)
   !If errorcode() then
   !  Message('Assert finding key in FieldMgr Set: ' & pkeyName,'Set Assert')
   !  return(Return:Fatal)
   !end
   Assert(Errorcode()=0)
   If Omitted(3)
     Set(SELF.KeyQ.TheKey)
   Else
     Set(SELF.KeyQ.TheKey,OtherKey)
   end
   Return(Choose(ErrorCode()=0,0,3))

FldMgrClType.Next       procedure()!,byte,proc
  code
  Assert(~SELF.Fm&=NULL)
  Return(SELF.FM.NEXT())

FldMgrClType.Previous   Procedure()!,Byte,proc
  Code
  Assert(~SELF.Fm&=NULL)
  Return(SELF.FM.Previous())