
  ! Random phrase generator

  PROGRAM

  MAP
  END

PhraseLen       BYTE(8)
Phrase25Percent BYTE,AUTO
Phrase          STRING(99),AUTO
SecureClipboard STRING(99),AUTO
Loops           BYTE,AUTO
LoopCount       LONG,AUTO
Min25Percent    BYTE(1)
MixedCase       BYTE(1)
NoRepeat        BYTE(1)
IgnoreCase      BYTE(1)
OmitConfusion   BYTE(1)
NumCount        BYTE,AUTO
AlphaCount      BYTE,AUTO
LoCount         BYTE,AUTO
HiCount         BYTE,AUTO
PrevChr         STRING(1),AUTO
String57        STRING('abcdefghijkmnopqrstuvwxyz23456789ABCDEFGHJKLMNPQRSTUVWXYZ')
String62        STRING('abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ')

Window WINDOW('  RanDum Phrase Generator'),AT(,,231,141),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:ANSI),CENTER,SYSTEM, |
         GRAY,DOUBLE
       PROMPT('Length:'),AT(5,6),USE(?LenPrompt)
       SPIN(@n2),AT(49,6,25,10),USE(PhraseLen),IMM,REQ,RANGE(8,99),REPEAT(20),DELAY(20),STEP(1)
       CHECK('Insure a minimum of 25% numeric characters '),AT(49,20),USE(Min25Percent)
       CHECK('Insure a minimum of 25% mixed case '),AT(49,32),USE(MixedCase)
       CHECK('Do not allow repeating characters '),AT(49,44),USE(NoRepeat)
       CHECK(' ... Regardless of case '),AT(65,56),USE(IgnoreCase)
       CHECK('Omit for clarity: upper(o), zero, upper(i), lower(L), one '),AT(49,69),USE(OmitConfusion)
       BUTTON('Generate To Clipboard'),AT(47,83,101,14),USE(?GenButton),DEFAULT,REQ
       TEXT,AT(48,104,179,33),USE(Phrase),SKIP,FONT('Courier New',10,COLOR:Black,FONT:regular,CHARSET:ANSI), |
           COLOR(COLOR:BTNFACE),READONLY
     END

  CODE

  SYSTEM{PROP:Icon} = '~rdwin.ico'

  OPEN(Window)

  ACCEPT
    CASE EVENT()
    OF EVENT:Accepted
      CASE FIELD()
      OF ?NoRepeat
        IF NoRepeat
          ENABLE(?IgnoreCase)
        ELSE
          IgnoreCase = FALSE
          DISPLAY(?IgnoreCase)
          DISABLE(?IgnoreCase)
        END

      OF ?GenButton
        UPDATE()
        LoopCount       = 0
        Phrase25Percent = ROUND((PhraseLen / 4), 1)
DumLoop LOOP
          LoopCount += 1
          Phrase = ''
          LOOP Loops = 1 TO PhraseLen
            Phrase[ Loops ] = CHOOSE(NOT OmitConfusion, String62[ RANDOM(1,62) ], String57[ RANDOM(1,57) ])
          END

          IF Min25Percent
            NumCount = 0
            LOOP Loops = 1 TO PhraseLen
              NumCount += CHOOSE(NUMERIC(Phrase[ Loops ]))
            END
            IF NumCount < Phrase25Percent THEN CYCLE.
          END

          IF MixedCase
            LoCount    = 0
            HiCount    = 0
            AlphaCount = 0
            LOOP Loops = 1 TO PhraseLen
              IF NUMERIC(Phrase[ Loops ]) THEN CYCLE.
              HiCount    += CHOOSE(INRANGE(VAL(Phrase[ Loops ]), 65, 90))
              LoCount    += CHOOSE(INRANGE(VAL(Phrase[ Loops ]), 97, 122))
              AlphaCount += 1
            END
            IF HiCount < Phrase25Percent OR LoCount < Phrase25Percent THEN CYCLE.
          END

          IF NoRepeat
            PrevChr = ''
            LOOP Loops = 1 TO PhraseLen
              IF IgnoreCase
                IF UPPER(Phrase[ Loops ]) = PrevChr THEN CYCLE DumLoop.
                PrevChr = UPPER(Phrase[ Loops ])
              ELSE
                IF Phrase[ Loops ] = PrevChr THEN CYCLE DumLoop.
                PrevChr = Phrase[ Loops ]
              END
            END
          END

          BREAK
        END
        0{PROP:Text} = '  RanDum Phrase Generator  ( loops: ' & LoopCount & ' )'
        DISPLAY(?Phrase)
        SETCLIPBOARD(Phrase)
      END
    END
  END

  SecureClipboard = CLIPBOARD()
  IF CLIP(SecureClipboard) = CLIP(Phrase)
    SETCLIPBOARD('')
  END

  CLOSE(Window)
  RETURN

