 Member
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

 Map
   subclassfunc1(unsigned,unsigned,UNSIGNED,long),long,pascal
   Module('api')
     Include('RulerCl.PRO')
   End
 end

!Includes this class and others
 include('RulerCl.inc')

RulerInitializing byte(1)
RQueue      Queue
hwndImage       signed
HRulerFEQ       Long  !Horizontal Ruler Image control
VRulerFEQ       Long  !Vertical Ruler Image Control
ImageFEQ        Long  !Main image control
SavedProc1      Long
  End






subclassfunc1        FUNCTION (unsigned hwnd, unsigned wmsg, UNsigned wparam, long lparam)
  CODE
  !Get RQueue.SavedProc1 or abort
  If ~RulerInitializing then !Dont change RQueue while starting up
    RQueue.hWndImage = hwnd
    get(RQueue, RQueue.hwndImage)
    If ~Errorcode() then 

      If wmsg=114H then  !Wm_HScroll message
        RQueue.HRulerFEQ{prop:xorigin} = RQueue.ImageFEQ{prop:Xorigin}
        !showscrollbar(RQueue.HRulerFEQ{prop:handle},3,0)
      end

      If wmsg=115h then  !Wm_VScroll message
        RQueue.VRulerFEQ{Prop:Yorigin} = RQueue.ImageFEQ{prop:YOrigin}
        !showscrollbar(RQueue.VRulerFEQ{prop:handle},3,0)
      end
    else
      return(1)
    end
  else
    return(1)
  end
  
  !Default processing
  Return(callwindowProc(RQueue.SavedProc1,hwnd,wmsg,wparam,lparam))

!-------------------------------------------------------------
!---Start of RulerClass class
!-------------------------------------------------------------
RulerClassType.Init                  Procedure(Window pWindow, Long pImageFEQ)
SM_CXVSCROLL  Equate(2)
SM_CYHSCROLL  Equate(3)

  Code
  RulerInitializing = True
  Clear(SELF)
  Clear(RQueue) !prepare a new instance
  SELF.HBarHeight = GetSystemMetrics(SM_CYHScroll)
  SELF.VBarWidth  = GetSystemMetrics(SM_CXVScroll)

  SELF.ThisWindow &= pWindow
  RQueue.ImageFEQ   = pImageFEQ

  SetTarget(SELF.ThisWindow)
  RQueue.hwndImage  = RQueue.ImageFEQ{prop:handle}
  SetTarget(SELF.ThisWindow)
  0{prop:Pixels}=1
  If SELF.AddHRuler() or SELF.AddVRuler() then
    RulerInitializing = False
    Return(level:Fatal)
  else
    SELF.RulerActive=True
    Add(RQueue,RQueue.HwndImage)
    SELF.RePosSize(RQueue.hwndImage)
  end
  SetPencolor(color:yellow)
  box(RQueue.ImageFEQ{prop:Xpos}-SELF.VrulerWidth,Rqueue.ImageFEQ{prop:Ypos}-SELF.HrulerHeight,self.vRulerWidth,Self.hrulerheight,Color:Yellow)
  !initiate the subclass of the image control
  RQueue.SavedProc1 = SetWindowLong(RQueue.ImageFEQ{Prop:handle},-4,Address(SubClassFunc1))
  Put(RQueue)
  SELF.ResetRuler()
  RulerInitializing = False
  Return(Level:Benign)

RulerClassType.SetInstance Procedure(Unsigned pHwndImage)
  Code
  RQueue.hWndImage = pHwndImage
  Get(RQueue, RQueue.hwndImage)
  If Errorcode() then return(1) else Return(0).

RulerClassType.AddHRuler  Procedure()
!It is assumed that The x,y position and size and width of the ruler is correct
! and that the ABC resizer logic will not move it.
  Code
  SetTarget(SELF.ThisWindow)
  RQueue.HRulerFEQ = Create(0,Create:Image)
  If ~RQueue.HRulerFEQ then Return (Level:Fatal).

  SELF.hRulerHeight=30
  !Make room for the ruler
  RQueue.ImageFEQ{prop:height}= RQueue.ImageFEQ{prop:Height} - SELF.hRulerHeight
  RQueue.ImageFEQ{prop:YPos}=RQueue.ImageFEQ{prop:YPos}+SELF.hRulerHeight
  RQueue.HRulerFEQ{prop:hScroll}=1
  RQueue.HRulerFEQ{prop:VScroll}=0
  RQueue.HrulerFEQ{Prop:TEXT}='~hruler.bmp'
  Unhide(RQueue.hrulerFEQ)
  Return(Level:Benign)

RulerClassType.AddVRuler  Procedure()
!It is assumed that The x,y position and size and width of the ruler is correct
! and that the ABC resizer logic will not move it.
  Code
  SetTarget(SELF.ThisWindow)

  RQueue.VRulerFEQ = Create(0,Create:Image)
  If ~RQueue.VRulerFEQ then Return (Level:Fatal).

  SELF.VRulerWidth=30
  RQueue.VrulerFEQ{prop:width}=Self.VrulerWidth
  RQueue.VrulerFEQ{prop:height}=RQueue.ImageFEQ{prop:height}
  Rqueue.VrulerFEQ{prop:Xpos}=Rqueue.ImageFEQ{prop:Xpos}
  Rqueue.vRulerFEQ{prop:YPos}=RQueue.ImageFEQ{Prop:ypos}
  RQueue.VRulerFEQ{prop:hScroll}=0
  RQueue.VRulerFEQ{prop:VScroll}=1
  !Make room for the ruler
  RQueue.ImageFEQ{prop:Width}= RQueue.ImageFEQ{prop:Width} - SELF.vrulerwidth
  RQueue.ImageFEQ{prop:XPos}=RQueue.ImageFEQ{prop:XPos}+SELF.vrulerwidth
  RQueue.VRulerFEQ{prop:text}='~vruler.bmp'
  unhide(RQueue.VRulerFEQ)
  Return(Level:Benign)
RulerClassType.RePosSize Procedure(Unsigned pHwndImage)

  Code
  !handles a resize 
  If ~SELF.RulerActive then Return.
  If SELF.SetInstance(phwndImage) then Return.
  SetTarget(SELF.ThisWindow)

  !Set RQueue.ImageFEQ position and height from the ruler height
  !RQueue.ImageFEQ{prop:Width}=0{prop:Width}-SELF.vrulerwidth
  !RQueue.ImageFEQ{prop:Height}=0{prop:Height}-SELF.hRulerHeight
  !RQueue.ImageFEQ{Prop:XPos}=SELF.vrulerwidth
  !RQueue.ImageFEQ{prop:YPos}=SELF.hRulerHeight

  RQueue.HRulerFEQ{Prop:Xpos}=RQueue.ImageFEQ{prop:XPos}
  RQueue.HRulerFEQ{prop:YPos}=RQueue.ImageFEQ{prop:YPos}-SELF.hRulerHeight
  RQueue.HRulerFEQ{prop:width} = RQueue.ImageFEQ{prop:Width}

  RQueue.VRulerFEQ{prop:Xpos}=RQueue.ImageFEQ{prop:XPos}-SELF.vrulerwidth
  RQueue.VRulerFEQ{prop:Ypos}=RQueue.ImageFEQ{prop:YPos}
  RQueue.VRulerFEQ{Prop:Height}=RQueue.ImageFEQ{prop:Height}

  Return


RulerClassType.ResetRuler Procedure()
  Code
  !Reposition Rulers
  If ~SELF.RulerActive then Return.
  SETTARGET(SELF.ThisWindow)
  RQueue.HRulerFEQ{prop:xorigin} = RQueue.ImageFEQ{prop:Xorigin}
  showscrollbar(RQueue.HRulerFEQ{prop:handle},3,0)
  RQueue.VRulerFEQ{Prop:Yorigin} = RQueue.ImageFEQ{prop:YOrigin}
  showscrollbar(RQueue.VRulerFEQ{prop:handle},3,0)

RulerClassType.Kill              Procedure(unsigned pHwndImage)
!destroy any dynamic objects and clean up
    Code
    !This code not currently called
    If ~SELF.RulerActive then Return.
    SELF.RulerActive = False
    If SELF.SetInstance(phwndImage) then Return.

    !unsubclass (Calling this method is optional)
    If RQueue.SavedProc1 then
      SetWindowLong(RQueue.ImageFEQ,-4,RQueue.SavedProc1)
    end
    Delete(RQueue) !Delete the instance
    RETURN

