    ! Clarion Magazine String Reference Example 7
    ! 6-15-2003
    !
    ! Demonstrates the use of String and CString References when dealing with a Win32 API call.
    ! Items stored as LONG addresses in a dynamically allocated STRING buffer.

    PROGRAM

    MAP
      MODULE('Win32API')
GetEnvironmentStrings   PROCEDURE(),LONG,PASCAL,NAME('GetEnvironmentStringsA')
FreeEnvironmentStrings  PROCEDURE(*STRING TheBuffer),SIGNED,RAW,PASCAL,PROC,NAME('FreeEnvironmentStringsA')
      END !MODULE
    END !MAP

MyBuffer            &STRING

AddressArray        &STRING
AddressArrayValue   LONG
AddressArrayRef     &LONG

BufferSize          LONG
StringCount         LONG

TempCString         &CSTRING
TempAddress         LONG,AUTO

DisplayQ            QUEUE
TheCString            CSTRING(255)
                    END !QUEUE

Counter             LONG
StorageLoop         BYTE

Window WINDOW('GetEnvironmentStrings Example'),AT(,,316,122),IMM,SYSTEM,GRAY
       STRING('DisplayQ of Fixed Length CSTRINGs from array of addresses'),AT(9,3),USE(?String2)
       LIST,AT(4,16,308,82),USE(?List2),VSCROLL,FORMAT('1024L(2)|MS(1024)'),FROM(DisplayQ)
       PROMPT('Buffer Size:'),AT(4,107),USE(?Prompt1)
       STRING(@N10),AT(46,107),USE(BufferSize)
       STRING('String Count:'),AT(118,107),USE(?String4)
       STRING(@N_10),AT(168,107),USE(StringCount)
     END ! WIndow

        CODE
        MyBuffer &= ( GetEnvironmentStrings() )
        TempAddress = ADDRESS(MyBuffer)

        TempCString &= ( TempAddress )

        StorageLoop = 0       ! Loop at least twice. Once to get sizes, and once to store the addresses.
        LOOP WHILE StorageLoop < 2
          TempAddress = ADDRESS(MyBuffer)
          TempCString &= ( TempAddress )
          Counter = 1  ! Reset the position counter.

          LOOP WHILE LEN(TempCString) <> 0

            IF StorageLoop = 0   ! Just the calculation loop
              BufferSize = BufferSize + (LEN(TempCString) + 1)
              StringCount += 1

            ELSE                 ! The storage loop
              AddressArrayRef &= ( ADDRESS(AddressArray) + (SIZE(AddressArrayValue) * (Counter - 1)) )
              AddressArrayRef = TempAddress
            END !IF
            Counter += 1
            TempAddress = TempAddress + LEN(TempCString) + 1
            TempCString &= ( TempAddress )
          END !LOOP

          IF StorageLoop = 0
            AddressArray &= NEW(STRING( StringCount * SIZE(AddressArrayValue)))
          END !IF
          StorageLoop += 1
        END !LOOP

        BufferSize += 1  ! Add the last null byte

        LOOP Counter = 1 TO StringCount
          AddressArrayRef &= ( ADDRESS(AddressArray) + (SIZE(AddressArrayValue) * (Counter - 1)) )
          TempCString &= ( AddressArrayRef )
          DisplayQ.TheCString = TempCString
          ADD(DisplayQ)
        END !LOOP

        OPEN(Window)
        ACCEPT
        END !ACCEPT

        FREE(DisplayQ)

        DISPOSE(AddressArray)
        FreeEnvironmentStrings(MyBuffer)
        RETURN

