#!
#! <TemplateSetName>
#! Replace all instances with the name of your template set
#!
#! <TemplateType>
#! Replace with whatever template type fits your purpose
#!
#! <TemplateDescription>
#! Replace all instances with the description of this template
#!
#! <DefaultObjectPrefix>
#! Replace all instances with the default name or prefix of your object
#!
#! <ClassName>
#! Replace all instances with the name of your class
#!
#TEMPLATE(<TemplateSetName>,'Class Wrapper Example'),FAMILY('ABC')
#!------------------------------------------------------------------------------
#<TemplateType>(UniqueTemplateName,<TemplateDescription>)...
#!------------------------------------------------------------------------------

#INSERT(%OOPPrompts(ABC))

#PREPARE
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem(ABC), '<DefaultObjectPrefix>' & %ActiveTemplateInstance)
  #CALL(%SetOOPDefaults(ABC), '<DefaultObjectPrefix>' & %ActiveTemplateInstance, '<ClassName>')
#ENDPREPARE

#ATSTART
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem(ABC), '<DefaultObjectPrefix>' & %ActiveTemplateInstance)
  #CALL(%SetOOPDefaults(ABC), '<DefaultObjectPrefix>' & %ActiveTemplateInstance, '<ClassName>')
#ENDAT

#SHEET
  #TAB('Setup')
    #DISPLAY('Your template prompts')
  #ENDTAB
  #TAB('Class')
    #WITH(%ClassItem, '<DefaultObjectPrefix>' & %ActiveTemplateInstance)
      #INSERT(%ClassPrompts(ABC))
    #ENDWITH
  #ENDTAB
#ENDSHEET

#AT(%GatherObjects)
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem(ABC), '<DefaultObjectPrefix>' & %ActiveTemplateInstance)
  #ADD(%ObjectList, %ThisObjectName)
  #SET(%ObjectListType,'<ClassName>')
#ENDAT

#AT(%LocalDataClasses)
#CALL(%SetClassItem(ABC), '<DefaultObjectPrefix>' & %ActiveTemplateInstance)
#INSERT(%GenerateClassDefinition(ABC), %ClassLines)
#ENDAT

#AT(%ProcedureRoutines)
#CALL(%GenerateVirtuals(ABC), '<DefaultObjectPrefix>' & %ActiveTemplateInstance, 'Local Objects|Abc Objects|<TemplateDescription>', '%EmbedVirtuals(<TemplateSetName>)')
#ENDAT

#AT(%<ClassName>MethodCodeSection,%ActiveTemplateInstance),PRIORITY(5000),DESCRIPTION('Parent Call'),WHERE(%ParentCallValid())
  #CALL(%GenerateParentCall(ABC))
#ENDAT

#!
#! -----  REQUIRED GROUPS  -----
#!
#GROUP(%EmbedVirtuals, %TreeText, %DataText, %CodeText)
#EMBED(%<ClassName>MethodDataSection, '<TemplateDescription> Method Data Section'),%ActiveTemplateInstance,%pClassMethod,%pClassMethodPrototype,LABEL,DATA,TREE(%TreeText & %DataText)
  #?CODE
  #EMBED(%<ClassName>MethodCodeSection, '<TemplateDescription> Method Code Section'),%ActiveTemplateInstance,%pClassMethod,%pClassMethodPrototype,TREE(%TreeText & %CodeText)
#!
#!
#GROUP(%ParentCallValid),AUTO
#DECLARE(%RVal)
#CALL(%ParentCallValid(ABC)),%RVal
#RETURN(%RVal)
